CommandLineParser (Grails 2.3.8)
Date: 2014-04-24

Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.codehaus.groovy.grails.cli.parsing
[Java] Class CommandLineParser

    java.lang.Object
      org.codehaus.groovy.grails.cli.parsing.CommandLineParser

    public class CommandLineParser
    extends java.lang.Object

Command line parser that parses arguments to the command line. Written as a replacement for Commons CLI because it doesn't support unknown arguments and requires all arguments to be declared up front. It also doesn't support command options with hyphens. This class gets around those problems.

Authors:
  Graeme Rocher

Since:
  2.0

Method Summary
`void` | `addOption(java.lang.String name, java.lang.String description)` Adds a declared option
`protected DefaultCommandLine` | `createCommandLine()`
`static CommandLine` | `getCurrentCommandLine()`
`java.lang.String` | `getOptionsHelpMessage()`
`CommandLine` | `parse(java.lang.String... args)` Parses the given list of command line arguments.
`CommandLine` | `parseString(java.lang.String string)` Parses a string of all the command line options converting them into an array of arguments to pass to #parse(String..args)
`CommandLine` | `parseString(java.lang.String commandName, java.lang.String args)` Parses a string of all the command line options converting them into an array of arguments to pass to #parse(String..args)
`protected void` | `processOption(DefaultCommandLine cl, java.lang.String arg)`
`protected void` | `processSystemArg(DefaultCommandLine cl, java.lang.String arg)`

Methods inherited from class java.lang.Object
java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

Method Detail

### addOption

    public void addOption(java.lang.String name, java.lang.String description)

  Adds a declared option
  Parameters:
    `name` - The name of the option
    `description` - The description

### createCommandLine

    protected DefaultCommandLine createCommandLine()

### getCurrentCommandLine

    public static CommandLine getCurrentCommandLine()

### getOptionsHelpMessage

    public java.lang.String getOptionsHelpMessage()

### parse

    public CommandLine parse(java.lang.String... args)

  Parses the given list of command line arguments. Arguments starting with -D become system properties, arguments starting with -- or - become either declared or undeclared options. All other arguments are put into a list of remaining arguments
  Parameters:
    `args` - The arguments
  Returns:
    The command line state

### parseString

    public CommandLine parseString(java.lang.String string)

  Parses a string of all the command line options converting them into an array of arguments to pass to #parse(String..args)
  Parameters:
    `string` - The string
  Returns:
    The command line

### parseString

    public CommandLine parseString(java.lang.String commandName, java.lang.String args)

  Parses a string of all the command line options converting them into an array of arguments to pass to #parse(String..args)
  Parameters:
    `commandName` - The command name
    `args` - The string
  Returns:
    The command line

### processOption

    protected void processOption(DefaultCommandLine cl, java.lang.String arg)

### processSystemArg

    protected void processSystemArg(DefaultCommandLine cl, java.lang.String arg)

Groovy Documentation